Setting up AVD
===

Go to AVD Manager
---

<img src="https://lh3.googleusercontent.com/PbrcQ0rdD1KymBqHznLGNJNGoklbLtnVjLFSONkNN1qyqwtFc7dHOwnhfGfxRmutXIQLhVTlqp3z-w8I1K5mHKdd5INDTAy4npSFJ7ZrNSUcoj-PQUgT6cirFKqUM6dGln9UdRyX04BgUf8SDL5iWacEmEuTmJsA-Q4VGMMxV4_KpiIZxhdM-jiGS8FrZ-heChc195L_vUcuplJOd8eN194clIFcPFv4GwE405hliW_5S2b1xSCquCfd4tEWP7xtOuAEPky-mgyoysNHCeYSnvak0p3kTX2b9HAFrUlTL6Gl87_QM-88GE1MXTFoXHi-IdSRfSXVvFG4uVSzQyGM2iKDCU4-z9KJgYMRQUAP7yJp37CvrLo9LOvXhr_GnIWnOzlRcZ2KVXb95huCOxZmYwm0Q78TVp6XDeRQjK8HAlo-Ey777-wjEpWasNFFQEnbNUhEQzVnvdHgiBVW285VpAlAjBVn3NnEN-qnxaNQnm1CUWxwJRc0Y41dbzsjx3h3ANmtUv3_6AbHmZgw0TKSZYtb28lRjJVQGL7vaSvTXiGdLyX71FERmYALnMZLvwX7LJc2lx16VsO0eBRIsAjoB1B6ssIoCF4FLFx9uqNi2UgXE0NX9w=w2304-h1440-no" alt="Open AVD" style="width: 600px;" />

Create a virtual device
---

<img src="https://lh3.googleusercontent.com/U6TTlTV4MTsMJvjaFhUIaTdDmumChoq1k0gKaJDaeODAJJ6H_H5mwK0xZdYSza6PoJ7-NVQfUSp-UZmRvDeSCR-UoFRLMH0qyHNej1OHfxesSpLzPyP0nwIuQsiSEJbn15vWCMK7Xo74unestqaeg1UOi7l6Xnzyc96udlYpFoyQV5iyqoNIuo_Oze4fenaXTcRjygB-95O15zI2RBOSqASNxkwvbwWOmUDpojbdCWqVpX2smokBKJpD7tx2TWwWQbH2EGBO1zxjs2E5EYVfTGXBe02LXxZR5ofmF652mS9iw7iX0Eb-KI6_Jgrw8InNb6Q-t_i_p8ex6Z9EbWFldteJ0ue7A-_Y7em2nmRHIqcOZslKuSEhwfbHuuwoqguheVJWdd4mUKfnwPMQJUqe9pKHxAdr_q7JlcUs7PQRC4wq4KEOvAqpbj0okndFr-OvabjCQH0uRtuF547NWDLM92AeGlQTI08JrR3Uulbyk6-gOwadt17dk_iRe5GXJt7hxrohguVYWEKi6bA25YbVP6pAG2jUaYEdXltzgoUNcys5-jfRnhZ0dgjEuoMqmv8hF75SbDvX1zfs_eOorBMm9zvBtS-fnBuSjibTgZgNglRHZaN_9Q=w2304-h802-no" alt="Create virtual device" style="width: 600px;" />

Choose a device to emulate 
---

I use a nexus 6P, but feel free to pick whichever you want.

Note that you will be restricted to the OS you can load onto it.

Also you will only see google developer devices in this list. You can't, for instance, create a S7 emulator.

<img src="https://lh3.googleusercontent.com/TxMjaiq9BZN6nU4XWi6Ry603B5ANqQOWUOtLxXtCna6zalab1lcQ-pfZxozoug60TzYdwZtioFUcD-E5qXy2PldMcLHfIiEEjNJwHfiSL73AWBdxSv3ZrzkoU-xoL3ZWYKt725twXDHRPk1yqd5LNP6caY7cQHQyM3mpRFM-gyPl7knmoU7M6uAE2_PIOa8zAJpSZ0Ws9-37cXrEYZ5f3vc0DaH3Noio0_4wgcZkizjvinWZJJgnEzJN-2KnTKgp_PWDi3WW9NBzVl1owQ2bOv0sNLPb_kVg_zrRQusOKhX2wR5gwBDEgJniZmdwr5cm2elpDjiycxrWuSdHPgeLvtUV44PllR8tQsWJPWxM-HAFezVQkSxUea-FAweDUnVu6Bxe9nkAV_t4Ps_7rrpXM6Hmth0Hqedg7emF6h4-EV4kEvZYMbry9eEjYa3bOMdt4AjmYz-ARF2dKx9e92NPIdwIMOKV2xj6AU4PqNuuhgwrQu0udstf7p_9a8A7GmcbE7SUdkqQj_cbOL9-xN67yojvkB1j9FgFI5vWE6wBmtJDqk49XuzeH7aM5RfHMxEsMLYmEx0MjD6mLLlPAw4qyaQn-AIZO96OntZ997RX1i2rtJFzOw=w2000-h1530-no" alt="Pick a device to emulate" style="width: 600px;" />

Choose a system image 
---

I'm going to pick the newest one Nouget (7.0), but I'll need to download it first.

<img src="https://lh3.googleusercontent.com/vhLGDvryCd3ogiOuD_8FkttT_sQ9VgDUi3D22Fry6jmQ1As9uVechUZAFA00hgHSkr4xZOaTcG47HPyEXDSCjU8uP5LbdxNd-2mI2BoQfwoqPatZW-xmBPkgHCrd5ceDmOQ64RZFruOw77lvADcdKYL8MqDXdZ5cbyOPUneaSNlU1k0fnS1c7ydeOzjNn5ZKiNXFc6FIWs0Xi0hBlhptVGCBFiVw8UpQ-DbKmXx8BsJVJ6kuOtubyN0lmujrQwgb0GxK-Jm_ACq6Ciu40nv7x0ow8W2wpP4gXW6ALwYYJwYFXhdhQMJ2GDnDJ-H5u3dHRjqUMhs6PxKPkEuIAhv0Ok-m14RIe5WmEbyHG4zDw7NNmB2Jph8Vfsa4VW1pYwWpRlnzxNqzDk324dYsizS4wn2VmN5pylISWpzRJ8pfXqXsA5i_UMhK8stTSsEgrZtj6mYK3OQ0_EtuYKPUlaKdQTrFUVDPVtXY_g9wpIsPiYLOP-xHW_HcqJY_iKM9G54U1oZz6BLqDnvFP8rahIik7j06dz7U837K3eX4bPwdLeY6AcmevKHEl0HEwKizjh7Gpp-1b5ch4F9LTyIdc-beuZY18-jGEaAju7ntx7AaiS18bNYdwQ=w2006-h1532-no" alt="Choose system image" style="width: 600px;" />

Once it is downloaded, you can create the device with the specified image.

Name the device
---

You can also configure it in more detail if you click "Show Advanced Settings"


<img src="https://lh3.googleusercontent.com/o1e0n3oRvpx43rGIbOs5G4nu5ZczXgbftn6gwsiYltoBsMKLWHIrD6ONXyGGFnYlWZPELPeOtMY12hJKpGTOXFRHA8HZz9GbRIj1WLJ96lOUMfA0Mvjwj_2m7i6q0b8_e8I3rJUixjHhb-SIJ0RB6CmPdvJQ1Zh9ce22k03q1vADP6oPbFyZARDK7Pgw70O8tRYzPw15j3WWz-03Iq9D5Qik1l_zIs04114hE1WBr74FyqtCMFqddn_Y1hKu9gX_iFmlxSW4NCTJRTODwC-1n7T3vakEQk-9nvzNgQefLSGp-XqzQuB0X5iXqFSUut2l9fZhKreB6jy0abKKUAskS-crEiu9hPlMPmcrHKMG0ZNZanyNm-UFZkpSy9jRozEwMUN78jjCBMouiXrsHX-dSDfly9ytM1OemYZq3n9cEryIFAQwSbrTFx7AkAvxOrXxhLCW8s7BhsR9gMvVTkpywa9rTudfQSb-G7vi4bpyNzSIrmQB4vMQ24v5N8uIyG7vlL09YqpqAnFg8VWLxQYAvNGVg7IYSWEVzD1kwCDj9uvXtd5B1Wqjc45ALeD8GDv5y30uXiuK_AcybLIvxvsex0csphhBdzVh3MdrLkW6P-1gSVbt-g=w2002-h1528-no" alt="Name the device" style="width: 600px;" />


Start your device
---

You can start the device now and you can run your app on the device.

Note that the startup will fail if you have any virtual machines running (like in VM Ware or VirtualBox)

Load App onto device
---

To load the app onto the device, just hit the play button in android studio and select the device you just launched.

<img src="https://lh3.googleusercontent.com/my90E-Km8onHHNvR_Iz05iiMRBWmvug8e7p101_IILSanv2VS994TeXdF772I8Sah_DCX-BI7ZeTY6ceO5RZrykjAeOenMUE04MGUadwpY0AZ_UMi7SCTglh_EmNNChw030G9GKwQqL-ah-xl1chfWwDlgGAh63rRELT2FbGRJEYzYDgBH3GaZycXaFP2_MPPlUBkNVFsFng3Pt4K-AqOLxfSfgXwEjaIOU83dk1lHUJ4kcw4Img9Uk0iXyRZdSY8u0TEYIN56K4Ab7F6VmrSDuRUkwHc-Z0YQxQJ5VOCV-8fbvaJzOACmYaFM_B5FqYwVV4ef_edjZ_L91hZIN-L9FlSFXvNxiwUxb4w1UJobhrp7e-rEX5dcFJ4BoHoU3-wACNCT-imYe32v35fetSWsCzE-KMgsffd8duyVaLyGZF_ZnaktzniNgfVj-K8ct6Rm-P4TGGC7cvfOgR-qeRp-vvfJWyt94vsBO-6rsj__XXJ6i4WW-nnlU4szBoV3qRmzy0cbdUTPOSHb-H-NNSa6HN0p-BumGi97EBMJ0HEJRkvmwdCIR7PqcDQa-AxnQlvP16Mk2QFFITNNfoNuV_TaQk6r0cO4_jkNiCbC6i6QYowg1iGQ=w480-h277-no" alt="App installing and loading" style="width: 600px;" />

Instant run
---

If you see a lightning bolt next to your play button after initially installing the app, you have Instant Run enabled, which means you can hot swap code into the app without fulling installing the app again


<img src="https://lh3.googleusercontent.com/V2UPks87Q82ZzrtNKZ0OXsZ6GKqepWl9OWYYIDs6E5KnYM_TEingJLdO_8_a5gq3DS89QN6bVQIEKscYCdbmSFqd5jCQoy0f9q1fSXh6Bhun3PYLrCaeK9fVvH_WJjWLjtgP0bdHS8-_5ss72sIX-wcXPDi0W-1DJ9h0qykQTHUvnHhWP64viihTU-PimVHf7DgCVQxv8Z0qHpZQx-TZmXL2qFLemGHZ-CtdzhDMePwoeQvoiCDgqkle4Cyhi5hU1xApq56MP6A5aWMnL8hGSbxY2iIhSwGj1YoFLFIftM6oDww3j03zQEraA-X-qxB2fD1yGgaoH8Ji1FLa9f3mwue47D5o0FzCPl5eFq77Jq4vHsojpxDIC99Zpwg2a7_B23J6vXPICTOLzAhZFl0Dnr67v54y86GWzb1wkKhq78ImaUj8hiVkQ9xB9BVZ-03CXrWmQE-2FYL-oBO9N9-sZUapey1QkKhCspmCcZxYLL1Ah-2XqK5xS8gNJa19OUvDb4veyEuZ3zEFlltcc878LyKpxCZgCD6JO7JmfAPIt1qatWTtmqFtIs2Z7A4MDkT548crYJcaXaEeWSOAFAnGSKhila06EzOeg9C9ew6nSbwAR7vCOQ=w480-h834-no" alt="Instant run" style="width: 200px;" />

If you hit the toast button, we can see there is some text there already, lets change it!


<img src="https://lh3.googleusercontent.com/WMSCp67oxv4rT58eTxkUnG0dVzPCRbfDaZW7cv29mnpSzMHNu8jINYpdwueJv-8zsSER26TpEL81d1sE_loGtwUxAga6Uf7qk4ktjYm0CdrqP84cjzvlKzpAHrN1tPONLAiHklWlt9rEzEu2tBdJmxKKEZn-tmcOvh8tTZSkId95dFFi3n79mujcAY0ZG9VwJS_2GOfd6zMmmtdtXW6oxqoW6or-YARHVRJkZhCmDAwmHIcME_H6rqwi_j4SGxbMZRtG6G2kRERLrs5AuejAFOCsWeQMohqk6aFRVCME7jN83XYsciyV2drO-2IIRWTNm78Sj0_9QS8xTlc0z4bluVNB7JiEsNgSOKYgJtxdfnmJU3OEvUEbj7N6uTV-vJZuZIbWYFjRjt4qSuTOXTcVFJIsEudHHQiS7CpYaM9lOALjj3pyGfLNPRWnc6rT89xown_9-SEkUOJWV9fodXLemAhIC8go1D_3RScx4urxZC6aujGissIhnFSY1V9RLbL9p7kJEYW-duoFgZnoDyWw2AWj9o5vXmThJFRZZjO86N_mESrB6Wv0B0lEzFxyAY_18TUH94Uo_PaKCkCbP4x3IZ4UP9TtmGyAwKq7qRQmvO2mngM_gg=w480-h832-no" alt="Orignal toast text" style="width: 200px;"/>



We can change the toast text from "Replace with your own action" to "This is my custom toast text".

Go into the MainActivity class and change that text and hit run again. It will quickly restart the activity and your text will be changed when you hit the toast.

<img src="https://lh3.googleusercontent.com/621gkg0UMaubX6O-Y0Zf_XarF3t3EZ6Yr2z_7PVSJsYNtKTwr6NLRPGF9D1SYwzQStASgr_Y2st4yQM3SgxygyvUO1h1bpQT9nlXIDDUMS-G2SBv2fxAgsgnPfYBAi5qtDyvybxpyu0Fg6ZuFRJ-GonlE7xHizDk8VnCTu37hFXrDJ3i3ECn7-P3I7AAWRmMLicYN_nrJ8OGpl-yHu2Bu7BUzk1tGiAWd4h6xZZjxZw2skst27Er4TwESOy4UaJLrSnj-zSCgMEl_cIa4AxDF0U7QeXytqT0yrvm-6DMXnuLAjd5ACSjRiG5oa1aUHukidcwQyF1YHZRDEBMpTVnR_FfGf4rQC0kj2sU41h3v-h25Y-CB-L-OEGNxs6wL6WvsMDILAc8aBi5EWFW89E5kHpixVuktnUkXNjJQRQ11bIGoWRKMxPFGVYLaaQebl20YvLPlvNTYpANstuvSzilIScFkmZEMArFH7RVsX2m53qPEWJpKkGxKaW72O0W1VuH_oPlBzKRNopiq96UhS1fe-yS04auXjty-MkqceDVjnYnXn6Z44ReDsOXSHRA9ZCAH-hWUctiZstA6uIL0brrjWDgmCqMvdAqO8v9JkaeaBh8NXR4rQ=w480-h832-no" alt="New custom toast text" style="width: 200px;" />

NOTE: If you kill the app while using instant run, you will need to go through a full install again to get the most recent changes.